function batch_train(code,node_number,delays_number)
%-------------------------------------------------------------------------------------------------------------
%This program trains a network to simulate the Amplitudes of a subject category-------------------------------
%how many instances of the signal to be used---
global st fin;
if (isempty(st)==1)
    clear global st fin;
    st = 71;
    fin = 126;
end

Type = 'High';
hid1 = 30;
hid2 = 20;
hid3 = 10;
trfun_dir = 'LM'; %must be catalexis of a training algorithm's name! i.e. BFG (for trainbfg), LM (for trainlm) etc
tr_epochs = 100;
valid_set = 4;  %validation set size
%----------------------------------------------
clc;
global cnt
%----------------------------------------------
subcol = fin - st - delays_number;
%convert delays_number to string---------
str = int2str(delays_number);
%----------------------------------------
%convert electrode number to string--
str2 = int2str(node_number);
%------------------------------------
%name of file in which net is to be saved and loaded--------
sav = ['net_delay' str '_electr' str2];
%-----------------------------------------------------------
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\NN-predict_next\' Type '\' trfun_dir '\' sav];
%-----------------------------------------------------------
%load the appropriate matrix or return error-------------------------------------------
try
    cd(S2);
    ststr = int2str(st);
    finstr = int2str(fin);
    temp = [S2 '\' code '_batch_matrix(' ststr '-' finstr ')'];
    load (temp);
    %----------------------------------------------------------
    %if called through train_loop function will work for all subjects
    if (isempty(cnt)==1)
        clear global cnt;
        cnt = 0;
        while (cnt < 1) | (cnt > num)
            numstr = int2str(num);
            tmp = ['Leave out which subject? (1-' numstr '):   '];
            cnt = input(tmp);
        end
    end
    clear tmp numstr;
    %-----------------------------------------------------------
    col = size(MATRIX,2);
    lin = size(MATRIX,1);
    if (cnt > 1 & cnt < num)
        TEMP(:,1:(cnt-1)*subcol) = MATRIX(:,1:(cnt-1)*subcol);
        TEMP(:,((cnt-1)*subcol+1):(col-subcol)) = MATRIX(:,(cnt*subcol+1):col);
    elseif (cnt == 1)
        TEMP = MATRIX(:,(subcol+1):col);
    else
        TEMP = MATRIX(:,1:((cnt-1)*subcol));
    end
    clear MATRIX;
    col = size(TEMP,2);         %length of matrix
    colpsub = col/(num-1);      %rows per subjects
    trainsize = col-colpsub*valid_set;
    validsize = colpsub*valid_set;
    train_set = num-1-valid_set;
    %------------------------------------------------------------------------------------
    %randomly creating the training matrix and randomizing its columns
    fperm = randperm(num-1);
    for i=1:train_set
        TMATRIX(:,(i-1)*colpsub+1:i*colpsub) = TEMP(:,(fperm(i)-1)*colpsub+1:fperm(i)*colpsub);
    end
    perm = randperm(trainsize);
    for i=1:trainsize
        MATRIX(:,perm(i)) = TMATRIX(:,i);
    end
    clear TMATRIX;
    %------------------------------------------------------------------------------------
    %creating the validation matrix
    for i=1:valid_set
        VALID(:,(i-1)*colpsub+1:i*colpsub) = TEMP(:,(fperm(i+train_set)-1)*colpsub+1:fperm(i+train_set)*colpsub);
    end
    clear TEMP temp perm;
catch
    disp('Error in loading data matrix for batch training');
    error('Execute function make_batch_matrix with the appropriate parameters');
end
%--------------------------------------------------------------------------------------

%training the network-----------------------------------------
p{1} = MATRIX(lin-1,:);
t{1} = MATRIX(lin,:);
for i=1:(lin-2)
    Pi{i}=MATRIX(i,:);
end
clear MATRIX;
VV.P{1} = VALID(lin-1,:);
VV.T{1} = VALID(lin,:);
for i=1:(lin-2)
    VV.Pi{i}=VALID(i,:);
end

disp('Network building and training');
disp('----------------------------------------------------------------------------------------------------------------------------');

%defining the network----------------------
%save files using real number of subject
cnter = used_subj(cnt);
cntstr = int2str(cnter);
if cnter < 10
    cntstr = ['0' cntstr];
end
%---------------------------------------
str = [code '_batch_net(' ststr '-' finstr ')ex' cntstr '.mat'];
strpic = [code '_train_perf(' ststr '-' finstr ')ex' cntstr];
strx2 = [S2 '\' str];
temp = exist (strx2);
tr_str = ['train' trfun_dir];
if temp ~= 0
    load (str);
    net.trainParam.minstep = 1e-08;
    net.trainParam.goal = 0;
    net.trainParam.epochs = 2;
    epotmp = epo;
else
    if hid3 == 0
        net = newfftd([-30 30],[0:1:delays_number],[hid1 hid2 1],{'tansig' 'tansig' 'purelin'},tr_str);
    else
        net = newfftd([-30 30],[0:1:delays_number],[hid1 hid2 hid3 1],{'tansig' 'tansig' 'tansig' 'purelin'},tr_str);
    end
    net.trainParam.goal = 0;
    net.trainParam.mem_reduc = 1;
    net.trainParam.lr = 0.1;
    net.trainParam.epochs = tr_epochs;
    net.trainParam.show = 1;
    net.trainParam.minstep = 1e-20;
    epotmp = 0;
end
clear temp;
%------------------------------------------
strhid1 = int2str(hid1);
strhid2 = int2str(hid2);
if hid3 == 0
    newtmpstr = [strhid1 '-' strhid2 '(' ststr '-' finstr ')'];
else
    strhid3 = int2str(hid3);
    newtmpstr = [strhid1 '-' strhid2 '-' strhid3 '(' ststr '-' finstr ')'];
end
try
    cd (newtmpstr);
catch
    mkdir(S2,newtmpstr);
    cd (newtmpstr);
end
    [net,tr] = train(net,p,t,Pi,[],VV);
    epo = tr.epoch(end) + epotmp;
    perf = tr.perf(end);
    save (str,'net','epo','perf','maxM','minM');
    print('-dbmp', '-r80', strpic);

%------------------------------------------
%--------------------------------------------------------------