function make_batch_matrix(code,node_number,delays_number)
%-------------------------------------------------------------------------------------------------------------
%This program builds a matrix for batch training--------------------------------------------------------------

%disp('Enter the directory you want to access ("OCD", "Controls", "Schizo" e.t.c.)');
%code = input('There must exist an appropriately named file (i.e.: OCD_data.mat file):   ','s');
%node_number = input('Which electrode should be examined? (2-16):   ');
%disp('Enter the number of input delays for the network');
%delays_number = input('not including delay "0":   ');

%how many instances of the signal to be used---
global st fin;
if (isempty(st)==1)
    clear global st fin;
    st = 251;
    fin = 401;
end

Type = 'High';
trfun_dir = 'LM';
%----------------------------------------------

clc;
%manipulate strings and opening the appropriate *.mat file-------
SD = ['C:\Matlab\work\DATA\' Type '\'];
cd (SD);
S2 = [code '_data'];
load(S2);
yy = (1:size(AMP,3));
TAMP(:,:) = AMP(node_number-1,st:fin,yy);
clear AMP SD;
%----------------------------------------------------------------

%convert delays_number to string----------
str = int2str(delays_number);
%-----------------------------------------
%convert electrode number to string-- 
str2 = int2str(node_number);
%------------------------------------
%name of file in which net is to be saved and loaded--------
sav = ['net' '_delay' str '_electr' str2];
%-----------------------------------------------------------
%subdirectory name------------------------------------------
S1 = ['C:\Matlab\work\NN-predict_next\' Type '\'];
SX = [S1 trfun_dir];            %[S1 '\NN-predict_next\' trfun_dir]
S2 = ['C:\Matlab\work\NN-predict_next\' Type '\' trfun_dir '\' sav];   %['C:\Matlab\work\' Type '\' code '\NN-predict_next\' trfun_dir '\' sav]
%-----------------------------------------------------------
%make appropriate directory if it doesn't exist--------------------
try
    cd (S2);
catch
    try
        cd (SX);
    catch
        %try
            %tmpd = [S1, '\NN-predict_next'];
            %cd(tmpd);
            %catch
            %mkdir(S1, 'NN-predict_next');
            %end
        %mkdir(tmpd, trfun_dir);
        %cd(SX);
        mkdir (S1, trfun_dir);
        cd(SX);
    end
    mkdir(SX, sav);
    cd (S2);
end
clear temp,SX;
%-------------------------------------------------------------------

%keep in memory, only the data for the appropriate node-------------
%data matrix NAMP excludes all missing data-------------------------
num = length(yy);
counter1 = 0;
for i=1:num
    tmpAMP = TAMP(:,i);
    if any(tmpAMP)
        counter1 = counter1 + 1;
        NAMP(:,counter1) = TAMP(:,i);
        used_subj(counter1) = i;        %array indicating the subjects used
    end
end
num = counter1;
sizstr = int2str(num);
clear yy tmpAMP TAMP;
%-------------------------------------------------------------------

%build the appropriate matrix which has (fin-st-delays_number)*siz columns and  (delays_number+2) lines---------
tempcol = fin-st-delays_number;
col = 0;
lin = delays_number + 2;
for k=1:num
    clc;
    kstr = int2str(k);
    tstr = ['Processing subject ' code ' ' kstr ' of ' sizstr];
    disp(tstr);
    for j=1:tempcol
        col = col + 1;
        MATRIX(1:lin,col) = NAMP(j:(j+lin-1),k);
    end
end
clear NAMP k j S2 tempcol kstr tstr sizstr;
%-------------------------------------------------------------------------------------------------------------------
%preprocessing the matrix------------------------------------------------------------
MATRIX = transpose(MATRIX);
minM(1:col) = min(min(MATRIX));
maxM(1:col) = max(max(MATRIX));
maxM = maxM';
minM = minM';
MATRIX = tramnmx(MATRIX,minM,maxM);
MATRIX = transpose(MATRIX);
minM = minM(1);
maxM = maxM(1);
%------------------------------------------------------------------------------------
ststr = int2str(st);
finstr = int2str(fin);
temp = [code '_batch_matrix(' ststr '-' finstr ')'];
save (temp,'MATRIX','num','used_subj','maxM','minM');
%----------------------------------------------------